<?php
// This file is part of CodeRunner - http://coderunner.org.nz/
//
// CodeRunner is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// CodeRunner is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with CodeRunner.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Example set-up config variables for running tests of the ace-inline filter
 * which requires CodeRunner to be set up appropriately.
 *
 * DO NOT EDIT THIS FILE!
 *
 * To create your own test configuration, copy this file to
 * test-sandbox-config.php and edit that instead. In that file,
 * you only need to set configuration that is different from
 * the defaults below.
 *
 * These files are used by the setUp method in
 * qtype_coderunner_testcase.
 *
 * @package    qtype_coderunner
 * @copyright  2013 Richard Lobb, University of Canterbury
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */

defined('MOODLE_INTERNAL') || die();

set_config('jobesandbox_enabled', 1, 'qtype_coderunner');

// The next line is critical. For "normal" behat testing on the
// development server, we'd use 'localhost' as the jobe server.
// For testing in moodle-plugin-ci on the development server,
// we can just either use '172.17.0.1' to access the native
// jobe on local host (which includes matplotlib) or 
// just 'jobe' to access the Docker Jobe that the CI environment
// has set up.
//set_config('jobe_host', 'jobe', 'qtype_coderunner');
//set_config('jobe_host', 'localhost', 'qtype_coderunner');
set_config('jobe_host', '172.17.0.1', 'qtype_coderunner');

// Configuration extras, used only when testing.
set_config('jobe_apikey_enabled', 0, 'qtype_coderunner');
set_config('jobe_limits_enforced', 0, 'qtype_coderunner');

// Turn on the webservice for use by ace-inline-filter.
set_config('wsenabled', 1, 'qtype_coderunner');
