define("filter_ace_inline/local/apply_ace_editor",["exports","filter_ace_inline/local/ui_parameters","filter_ace_inline/local/display_ui","filter_ace_inline/local/file_helpers"],(function(_exports,_ui_parameters,_display_ui,_file_helpers){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.applyAceAndBuildUi=void 0;
/**
   * JavaScript for applying the ace editor.
   *
   * @module     filter_ace_inline/local/apply_ace_editor
   * @copyright  Richard Lobb, Michelle Hsieh 2022
   * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   */
const ACE_MODE_MAP={c:"c_cpp",cpp:"c_cpp",js:"javascript",nodejs:"javascript","c#":"cs",octave:"matlab","c++":"c_cpp",python2:"python",python3:"python",markup:"html"};_exports.applyAceAndBuildUi=async(root,isInteractive,config)=>{const className=isInteractive?"ace-interactive-code":"ace-highlight-code",alternativeName=isInteractive?"data-ace-interactive-code":"data-ace-highlight-code",preElements=root.getElementsByTagName("pre");for(const pre of preElements)if("none"!==pre.style.display){const uiParams=new _ui_parameters.UiParameters(pre);uiParams.extractUiParameters(isInteractive,config),(pre.classList.contains(className)||pre.hasAttribute(alternativeName))&&applyToPre(pre,isInteractive,uiParams)}const codeElements=root.getElementsByTagName("code");for(const code of codeElements)if(null!==code.parentNode&&"none"!==code.parentNode.style.display&&(code.hasAttribute(alternativeName)||code.classList.contains(className))){const uiParams=new _ui_parameters.UiParameters(code);uiParams.extractUiParameters(isInteractive,config),applyToPre(code.parentNode,isInteractive,uiParams)}};const applyToPre=async(pre,isInteractive,uiParameters)=>{const params=uiParameters.paramsMap;if(params["file-upload-id"]&&(0,_file_helpers.setupFileHandler)(params["file-upload-id"]),params.hidden){if(isInteractive){const getCode=()=>pre.innerText;(0,_display_ui.addUi)(pre,getCode,uiParameters)}}else setUpAce(pre,uiParameters,isInteractive);pre.style.display="none"},setUpAce=async(pre,uiParameters,isInteractive)=>{const params=uiParameters.paramsMap,darkMode=params["dark-theme-mode"];let theme=null;theme=2==darkMode||1==darkMode&&globalThis.matchMedia&&globalThis.matchMedia("(prefers-color-scheme: dark)").matches?"ace/theme/tomorrow_night":"ace/theme/textmate";const showLineNumbers=!!params["start-line-number"];let aceLang=params["ace-lang"]?params["ace-lang"]:params.lang;aceLang=aceLang.toLowerCase(),aceLang in ACE_MODE_MAP&&(aceLang=ACE_MODE_MAP[aceLang]);const mode="ace/mode/"+aceLang,text=pre.textContent,lines=text.split("\n"),numLines=lines.length,longestLine=longest(lines),editNode=document.createElement("div");editNode.style.margin="6px 0px 6px 0px",editNode.style.lineHeight="1.3",editNode.style.width=pre.style.width?pre.style.width:"100%",editNode.style.resize="none",pre.after(editNode);let aceConfig={newLineMode:"unix",mode:mode,minLines:Math.max(numLines,params["min-lines"]),maxLines:params["max-lines"],fontSize:params["font-size"],showLineNumbers:showLineNumbers,firstLineNumber:params["start-line-number"],showGutter:showLineNumbers,showPrintMargin:!1,autoScrollEditorIntoView:!0,highlightActiveLine:showLineNumbers};const editor=globalThis.ace.edit(editNode,aceConfig),session=editor.getSession();if(!pre.style.hasOwnProperty("width")||0==pre.style.width){const aceWidestLine=Math.ceil(lineLength(editor.renderer,longestLine)),minWidth=isInteractive?aceWidestLine+42:aceWidestLine;editNode.style.minWidth=minWidth+"px"}if(session.setValue(text),editor.setTheme(theme),null!==params.readonly&&(editor.setReadOnly(!0),editNode.classList.add("readonly")),isInteractive){const getCode=()=>editor.getSession().getValue();(0,_display_ui.addUi)(editNode,getCode,uiParameters)}else editor.renderer.$cursorLayer.element.style.display="none"},lineLength=(renderer,line)=>{const chars=renderer.session.$getStringScreenWidth(line)[0];return Math.max(chars,2)*renderer.characterWidth+2*renderer.$padding+2+0},longest=lines=>{let longest="";for(const line of lines)line.length>longest.length&&(longest=line);return longest}}));

//# sourceMappingURL=apply_ace_editor.min.js.map